<?php 
/**
* 实现从gb到unicode的编码
*
* @version 1.0.0
* @package Charset
*/

class __gb_unicode extends CharsetTool 
{
	/**
	* 构造函数
	*
	* @access public
	*/
	function __construct()
	{
		parent::__construct();	
	}	
	
	/**
	* 转换编码
	*
	* @param string $string 要转换的字符串
	* @return string 转换的结果
	* @access public
	*/
	public function convert($string)
	{
		if (!Pfc::has("gb_unicode_table"))
		{
			$lines = file($this->dir . "/Charset/tables/gb-unicode.table");
			Pfc::set("gb_unicode_table", $lines);
		}
		else 
		{
			$lines = Pfc::get("gb_unicode_table");	
		}
		$array = array();
		foreach ($lines as $v)
		{
    		$array[hexdec(substr($v, 0, 6))] = substr($v, 9, 4);
		}
		$chars = String::getChars($string);
		if (!empty($chars))
		{
			foreach ($chars as $index=>$char)
			{
				if (ord($char) > 127)
				{
					$chars[$index] = "&#x" . $array[hexdec(bin2hex($char)) - 0x8080] . ";";
				}
			}
			return implode("", $chars);
		}
		return null;
	}	
}

?>